/*
正体補正プログラム
超音波センサの番号は、次のようになっていることを前提としている。
	USS1:正面左側     USS2:正面右側

*/

#include <linux/errno.h>
#include <sys/io.h>
#include <unistd.h>
#include <math.h>
#include <time.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
//#include "hardware.h"
#include "serial_ctrl.h"
#include "motor.h"
#include "direction.h"
#include "state.h"


#define COUNT_MAX 10		// 正体補正を諦めるまでの回数
#define USSMAX	  254		//所定距離の最大値[cm]
#define USSMIN	  3		//所定距離の最小値[cm]
#define SLEEP	  0.1	//秒単位
#define TOLER     2		//正対補正許容範囲
#define USS_DIST  21	//超音波センサ間の距離
#define PWMS      30
#define PWMR      32
#define TOLER_R   4
static float ref_angle;
static int direction_endflag = 0;

/* 引数 dist：正体補正する物体までの距離 */
int direction_correct(int dist){
	direction_endflag = 0;

	int uss_l;			//left
	int uss_r;			//right
	int diff_uss;
	float diff_max=10;
	int c_count=0;
	int cur_dist;		//現在の前方との距離
	int ref_dist = 0;	//目標値
	int deviation = 0;
	int pwmr = 28;
	static int ref_deg;
	static int cur_deg;

	int ref_deg = base_angle;
	while (1) {
		cur_deg = compass_angle;
		if (cur_deg != 0) break;
		usleep(20000);
	}
	while (1) {
		if (abs(ref_deg - cur_deg) <= 3) {
			motor_drive(0,0);
			break;
		}
		else if ((ref_deg - cur_deg) > 0) {
			motor_drive(20, -20);
		}
			else {
			motor_drive(-20, 20);
		}
		usleep(20000);
	}

	ref_dist = dist;
	cur_dist = uss_distance[2];
	while (1){
		if (abs(ref_dist - cur_dist) <= 3){
			motor_drive(0,0);
			break;
		}
		else if ((ref_dist - cur_dist) > 0){
			motor_drive(24,24);
		}
		else {
			motor_drive(-24, 24);
		}
		usleep(20000);
	}
	return;
}

int direction_endflag_get(){
	return direction_endflag;
}

