
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <errno.h>
#include <unistd.h>
#include "motor.h"
#include "run_ctrl.h"
#include "state.h"
#include "serial_ctrl.h"

static int default_pwm_l = 40;
static int default_pwm_r = 45;
static float Kd = 320;
static float Kp = 2.8;

static pthread_t task_id;

static int flont_wall = 0;
static int ctrl_endflag = 0;
static int s_or_r = 0;


static int target_angle;
static int degs[2];

static int cur_deg = 0;
static int ref_deg = 0;

char io_data[2];
int io_count;


//スレッド作成後実行
static void *thread_code(void *t){
  	static float u_l, u_r;
	static float devx2=0.0;
	static float deva1=0.0, deva2=0.0;
	static int time = 20;
	static float run_x, run_a;

	static int count1 = 0;
	static int count2 = 0;
	static float devx1[15];



	while(1){

		switch(s_or_r){

			case 101:
			        if(count1 == 14){
			          count2 = 0;
			        }else{
			          count2 = count1+1;
			        }

				devx1[count1] = devx2;			//前ループの偏差を格納
				state_get_c(&devx2, &deva2);		//現在の偏差を取得
				run_x = Kp*devx2 + Kd*(devx2-devx1[count2])/(time*15);		//PD制御値(中心からの距離のずれ)
				//run_a = Kp*deva2 + Kd*(deva2-deva1[count2])/(time*15);		//PD制御値(中心からの角度のずれ)
		      		//run_x = run_x * 0.8;
				//PD制御値をduty比に整形
		      		u_r = (float)default_pwm_r;
		      		u_l = (float)default_pwm_l;
				if(run_x > 0){
					u_r = u_r + run_x;
				  }else{
					u_l = u_l + (-1)*run_x;
				}
			  	motor_drive((int)u_l, (int)u_r);	//duty比セット

				u_r = 0;
				u_l = 0;
			        if(count1 == 14){
			          count1 = 0;
			        }else{
			          count1++;
			        }


			          	if(170 < uss_distance[0]){
			              	motor_drive(20,40);
			              printf("壁が近づいているなう！\n");
			              ctrl_endflag = 1;
			              //sleep(0.5);
			              goto END;
			          }
				    
				break;

			case 110:
			        if(count1 == 14){
			          count2 == 0;
			        }else{
			          count2 = count1+1;
			        }

				devx1[count1] = devx2;			//前ループの偏差を格納
				state_get_u(&devx2, &deva2);		//現在の偏差を取得
				run_x = Kp*devx2 + Kd*(devx2-devx1[count2])/(time*15);		//PD制御値(中心からの距離のずれ)
				//run_a = Kp*deva2 + Kd*(deva2-deva1[count2])/(time*15);		//PD制御値(中心からの角度のずれ)
		      		//run_x = run_x * 0.8;
				//PD制御値をduty比に整形
		      		u_r = (float)default_pwm_r;
		      		u_l = (float)default_pwm_l;
				if(run_x > 0){
					u_r = u_r + run_x;
				  }else{
					u_l = u_l + (-1)*run_x;
				}
			  	motor_drive((int)u_l, (int)u_r);	//duty比セット

				u_r = 0;
				u_l = 0;
		        	if(count1 == 14){
		         	 count1 = 0;
		        	}else{
		         	 count1++;
		        	}


			      	if((flont_wall + 30) > uss_distance[2]){
			          if(100 < uss_distance[1]){
			              printf("壁が近づいているなう！\n");
			              //sleep(0.5);
			              goto END;
			          }
				}
				break;

			case 201:
				motor_drive(20,-20);
    				ref_deg = compass_angle;
    				if(degs[0] == 0){
	        			//printf("Angle is %d [deg]\n",degs[0]);
	    			} else {
					if(degs[0] < 360 - target_angle){
						//printf("Angle is %d [deg]\n",degs[0]);
						degs[1] = degs[0] + target_angle;
                 			} else {
						degs[1] = degs[0] - 180 - target_angle;
                 			}   
					if (abs(degs[1] - ref_deg) < 4){
						        goto END;
					}
				}
					break;

/*			case 201:
				motor_drive(20,-20);
    				ref_deg = compass_angle;
    				if(degs[0] == 0){
	        			//printf("Angle is %d [deg]\n",degs[0]);
	    			} else {
					if(degs[0] < 270){
						//printf("Angle is %d [deg]\n",degs[0]);
						degs[1] = degs[0] + target_angle;
                 			} else {
						degs[1] = degs[0] - 180 - 90;
                 			}   
					if (abs(degs[1] - ref_deg) < 6){
						        goto END;
					}
				}
					break;
*/

			case 210:
				motor_drive(-25,25);
    				if(degs[0] == 0){
	     				printf("Angle is %d [deg]\n",degs[0]);
	    			} else {
					  if(degs[0] > 90){
						  printf("Angle is %d [deg]\n",degs[0]);
						  degs[1] = degs[0] -90;
						  if (abs(degs[1] - compass_angle) < 10){
							  goto END;
						  }
					  } else {
						  printf("Angle is %d [deg]\n",degs[0]);
							degs[1] = degs[0] -270;
						  if(abs(degs[1] - compass_angle) < 6){
							  goto END;
						  }
				    	}
        			}
					break;
      
      case 211:
          cur_deg = compass_angle;
          if(abs(cur_deg - target_angle) < 4){
             motor_drive(0,0);
             goto END;
          }
          if(target_angle < cur_deg){
            motor_drive(-25,25);
          }
          else{
            motor_drive(25,-25);
          }

        break;

			case 300:
				motor_drive(23,90);
    				if(degs[0] == 0){
	     				printf("Angle is %d [deg]\n",degs[0]);
	    			} else {
					  if(degs[0] > 90){
						  printf("Angle is %d [deg]\n",degs[0]);
						  degs[1] = degs[0] -90;
						  if (abs(degs[1] - compass_angle) < 10){
							  goto END;
						  }
					  } else {
						  printf("Angle is %d [deg]\n",degs[0]);
							degs[1] = degs[0] -270;
						  if(abs(degs[1] - compass_angle) < 10){
							  goto END;
						  }
				    	}
        			}
					break;

			case 400:
				motor_drive(30,30);
				for(io_count = 0; io_count < 2; io_count++){
					io_get(io_data[io_count]);
					if(io_data[io_count] == '1'){
						goto END;
					} else if (infrared_data[0] == 0){
						goto END;
					}
				}
				break;
						

			case 401:
				motor_drive(-30,30);
				if(infrared_data[0] == 1){
					goto END;
				}
				break;

			case 402:
				motor_drive(30,-30);
				if(infrared_data[0] == 1){
					goto END;
				}
				break;



/*
    				if(degs[0] == 0){
	     				printf("Angle is %d [deg]\n",degs[0]);
	    			} else {
					  if(degs[0] > 90){
						  printf("Angle is %d [deg]\n",degs[0]);
						  degs[1] = degs[0] -90;
						  if (abs(degs[1] - compass_angle) < 10){
							  goto END;
						  }
					  } else {
						  printf("Angle is %d [deg]\n",degs[0]);
							degs[1] = degs[0] -270;
						  if(abs(degs[1] - compass_angle) < 10){
							  goto END;
						  }
				    	}
        			}
					break;
*/

/*
    case 300:
        printf("com %d\n",compass_angle);
				//printf("か～ぶ\n");
				motor_drive(-18, 18);
					degs[1] = compass_angle;
          //printf("%d %d\n",degs[0],degs[1]);
					if (degs[0] != degs[1]) {
						if (degs[1] -200  >  degs[0]) {
							ref_deg += + degs[0] + 360 - degs[1];
              //printf("%d\n",ref_deg);
							//printf("aaaaa%d\n", + degs[0] + 360 - degs[1]);
							degs[0] = degs[1];
						}
						else {
							ref_deg += degs[0] - degs[1];
							degs[0] = degs[1];
              //printf("%d\n",ref_deg);
						}
						if (ref_deg > 90) {
							printf("か～ぶおしまい\n");
							goto END;
				    }
			    }
				break;
*/
				 
			default:
				break;

	  	}
		usleep((time - 1) * 1000); //???
		//printf("%d\n",compass_angle);
	} //while
	END:
	motor_drive(0,0);
	ctrl_endflag = 1;
	
	return;	
} //function


/*スレッド作成
*joinしてないのでmainが終了するとこのスレッドは終了してしまう
*stateスレッドの作成も行う
*/
int run_ctrl_create(int s_or_r_set, int flont_wall_set, int target_angle_set, float road){ 
	ref_deg = 0;
	ctrl_endflag = 0;
  	road_width = road;	
	flont_wall = flont_wall_set;
	s_or_r = s_or_r_set; // s_r: 101 s_r:110 rot_r:201 rot_l: 210
  	target_angle = target_angle_set;
	
	state_create();
	if(pthread_create(&task_id, NULL, thread_code, NULL) == -1){
		error("threadが作成できない");
	}
  while(1){
    degs[0] = compass_angle;
    if(degs[0] != 0) break;
    usleep(20000);
  }
	return 0;
}

int run_ctrl_endflag_get(){
	return ctrl_endflag;
}

/*スレッドキャンセル
*stateスレッドのキャンセルも行う
*/
void run_ctrl_cancel(){
	ctrl_endflag = 0;
	state_cancel();
	pthread_cancel(task_id);
}
