#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include <stdint.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <termios.h>
#include <time.h>
#include "1603serial_ctrl.h"

#define DEV_NAME    "/dev/ttyACM0"        // デバイスファイル名
#define BAUD_RATE    B9600                // RS232C通信ボーレート
#define BUFF_SIZE    4096                 // 適当
#define ANALOGSTART  9
//#define O_RDWR		 "a+"

volatile int uss_distance[4];
volatile int infrared_date[4];
volatile int compassdate[2];
volatile int compass_angle;
static pthread_t task_id;
static int fd;

/*通信関数群*/

void serial_init(void)
{
    struct termios tio;
    memset(&tio,0,sizeof(tio));
    tio.c_cflag = CS8 | CLOCAL | CREAD;
    tio.c_cc[VTIME] = 100;
    // ボーレートの設定
    cfsetispeed(&tio,BAUD_RATE);
    cfsetospeed(&tio,BAUD_RATE);
    // デバイスに設定を行う
    tcsetattr(fd,TCSANOW,&tio);
}



int ttyUSB0(void){
    fd = open(DEV_NAME,O_RDWR);							// デバイスファイル（シリアルポート）オープン
    if(fd<0){											// デバイスの open() に失敗したら
        perror("デバイスファイルのオープンに失敗");
        return 1;
    }
    else{
    	printf("Arduino Open!! fd=%d\n",fd);
    }
    serial_init();                                    	// シリアルポートの初期化
	return 0;
}


/*スレッド本体*/

static void *thread_code(void *t){
	//static uint8_t getdata[2],checkdata[40]; // ,sortdata[20];
  static uint16_t getdata[2],checkdata[40];
  static uint16_t sortdata[20];
	static int an =0, i =0, j =0;
	static uint16_t compass;
	ttyUSB0();
	while(1){
		an = read(fd,getdata,1);
		if(an > 0){								//an(受信テータ数）が0以上なら（受信したら）
			checkdata[i] = getdata[0];
			i++;
			if(i >= (10+1)){					//受信データ数が1フレーム以上なら
				if(checkdata[0] == 'A'){		//先頭識別子チェック
				//	printf("\t\t");
					for(j=0;j<11;j++){
						sortdata[j] = checkdata[j];
					  	printf("d% ", j);
						printf("%02x ",sortdata[j]);
					}
					printf("\n");
					
					/*超音波データ加工*/
					uss_distance[0] = sortdata[3];
					uss_distance[1] = sortdata[4];
          				uss_distance[2] = sortdata[1];
          				uss_distance[3] = sortdata[2];

/*
					//printf("%d,%d,%d,%d\n",uss_distance[0],uss_distance[1],uss_distance[2],uss_distance[3]);

					infrared_date[0] = sortdate[5];
					infrared_date[1] = sortdate[6];
					infrared_date[2] = sortdate[7];
					infrared_date[3] = sortdate[8];
  				        
					compass_date[0] = sortdate[9];
					compass_date[1] = sortdate[10];
					compass_angle = compass_date[0] + compass_date[1];
*/					
					//受信データ初期化
					i = 0;
				}
				else{
					for(j=0;j<i;j++){
						checkdata[j] = checkdata[j+1];
					}
					i--;
				}
			}
		}
		else{
			sleep(0.02);
		}
	}
}

int serial_ctrl_create(){
	if (pthread_create(&task_id, NULL, thread_code, NULL) == -1){
		error("threadが作成できない");
	}
	return 0;
}

