#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <errno.h>
#include <unistd.h>
#include <math.h>
#include "serial_ctrl.h"
#include "state.h"

static pthread_t task_id;
static float devx_u = 0;	//中心線からのズレ
static float devx_c = 0;
static float deva = 0;	//正面を基準とした角度のズレ
float road_width = 0;	//道幅(cm)
float base_angle = 0;

//スレッド作成後実行
static void *thread_code(void *t){	
	float time = 0.02;
	float uss_l=0, uss_r=0;
	float uss_width = 20;	//左右のuss間
	float angle_r_u, angle_d_u, dist_l_u;	//横を基準とした角度(0~90), 左の壁との距離
  float angle_r_c, angle_d_c, dist_r_c;
	float devx2;

  int current_angle;
  while(1){
    base_angle = compass_angle;
    if(base_angle != 0) break;
    usleep(20000);
  }
	while(1){
		//ここでuss_l, uss_rにserial_ctrlからの値を入れる
		uss_l = uss_distance[0];
		uss_r = uss_distance[1];
   
    if(road_width == (uss_l + uss_r + uss_width)){
      base_angle = compass_angle;
    }
    current_angle = compass_angle - base_angle;
    angle_d_c = current_angle % 360;
    angle_r_c = 3.141592 * angle_d_c / 180;
    if(uss_r > (road_width/1.7)){
    }else{
      dist_r_c = (uss_r + uss_width / 2) * cos(fabs(angle_r_c));
    }

	  //printf("right:%f left:%f\n", uss_r, uss_l);
		devx2 = devx_u;

    
		//修正
		if ((uss_l > (road_width/1.7)) || (uss_r > (road_width/1.7))){
    }else{
			//ここでuss_l, uss_rにserial_ctrlからの値を入れる
			if (road_width > (uss_l + uss_r + uss_width)){
				angle_r_u = 0;
			}
			else{
				angle_r_u = acos(road_width / (uss_l + uss_r + uss_width));
			}
			dist_l_u = (uss_l + uss_width / 2) * cos(angle_r_u);		//左の壁との距離
		}
    

		angle_d_u = angle_r_u * 180 / 3.141592;		//radをdegに変換
    //printf("%f\n",angle_d);
		devx_u = dist_l_u - road_width/2;		//距離偏差の計算
    devx_c = road_width/2 - dist_r_c;
		//角度偏差の計算

    /*
		if((devx2-devx) > 0){
			deva = angle_d;					
		}else if((devx2-devx) < 0){
			deva = (-1)*angle_d;
		}else{
			deva = deva;
    }
    */

    //printf("x=%f\n",devx);
		sleep(time);
	}
	return NULL;
}

//データを渡す
void state_get_u(float *run_devx, float *run_deva){
	*run_devx = devx_u;
	*run_deva = deva;
}

void state_get_c(float *run_devx, float *run_deva){
  *run_devx = devx_c;
  *run_deva = deva;
}

//スレッド作成
int state_create(){
	if(pthread_create(&task_id, NULL, thread_code, NULL) == -1){
		error("threadが作成できない");
	}
	return 0;
}

//スレッドキャンセル
void state_cancel(){
	pthread_cancel(task_id);
}
